class Base64 {
  encode(param, encoding = 'utf8') {
    if (!param) {
      return null;
    }
    
    if (typeof param === 'object') {
      param = JSON.stringify(param);
    }

    const result = Buffer.from(param, encoding).toString('base64');

    return result;
  };

  decode(param, parseJson = true, encoding = 'utf8') {
    if (!param) {
      return null;
    }

    let result = Buffer.from(param, 'base64').toString(encoding);

    if (parseJson) {
      result = JSON.parse(result);
    }

    return result;
  };

  isValid(base64) {
    if(!base64) return false;
    const toCheckBase64 = /^([A-Za-z0-9+/]{4})*([A-Za-z0-9+/]{4}|[A-Za-z0-9+/]{3}=|[A-Za-z0-9+/]{2}==)$/;
    return toCheckBase64.test(base64);
  }
}

module.exports = new Base64();
