const cors = require('cors');
const consign = require('consign');
const path = require('path');
const auth = require('../../middleware/Auth')
const limit = '50mb';
const setupMiddleware = (app, express) => {
  app.use(cors());
  app.use(express.json({ limit }));;
  app.use(express.urlencoded({ extended: false, limit }));
  app.use(auth.isAuth.bind(auth));

  consign({ cwd: 'app', loggin: false, verbose: false });
  consign({ cwd: path.resolve(__dirname, '../../'), loggin: false, verbose: false })
    .then('middleware')
    .then('model')
    .then('controller')
    .then('service')
    .then('routes')
    .into(app);
}

module.exports = setupMiddleware;