const installerController = require('../../controller/InstallerController');
const SystemLogger = require('../../logs/SystemLogger');
const socketService = require('../../service/SocketService');

const route = (router) => {
  router.put('/installer/*', (async (req, res) => {
    installerController.upInstaller(req.body).then((services) => {
      if (services.rowsAffected > 0) {
        return res.status(200).json({ data: services.rowsAffected });
      }

      return res.status(400).json({ error: 'Dados incorretos' });
    }).catch((err) => {
      return res.status(400).json({ error: 'Erro ao atualizar o sistema no banco de dados' });
    });
  }));

  router.post('/installer/*', (async (req, res) => {
    installerController.addInstaller(req.body).then((services) => {
      if (services.rowsAffected > 0) {
        return res.status(200).json({ data: services.rowsAffected });
      }

      return res.status(400).json({ error: 'Dados incorretos' });
    }).catch((err) => {
      SystemLogger.error(`/installer/* - Erro: ${err.message}`);
      return res.status(400).json({ error: 'Erro ao atualizar o sistema no banco de dados' });
    });
  }));

  router.get('/installer/unitConnectionStatus', async (req, res) => {
    if(!req.body || !req.body.CDFILIAL) return res.status(400).json({ERROR: "Invalid Params"});
    const {CDFILIAL, CDCAIXA = null} = req.body;
    const CONNECTED = await socketService.getUpdaterSocket().hasUnitUpdaterConnected(CDFILIAL, CDCAIXA);
    res.status(200).json({ CONNECTED });
  });
}

module.exports = route;