const OracleService = require('../service/OracleService');

class updaterHistoricoModel 
{
  getUpdaterProdutoHistorico(cdProductId, cdFilial) {
    const sql = `
      SELECT
        H.CDFILIAL,
        O.NMOPERADOR,
        F.NMFILIAL,
        H.CDFILIAL
        || ' - '
        || F.NMFILIAL AS FILIAL,
        H.CDUUID,
        H.CDPRODUCTID,
        P.NMPRODUCT,
        H.IDSTEVENTO,
        NVL(H.NRVERSAOATUAL, '-') AS NRVERSAOATUAL,
        H.NRVERSAOALVO,
        H.IDCRIARVERSAO,
        TO_CHAR(H.DTULTATU, 'DD/MM/YYYY HH24:MI:SS') AS DTULTATU
      FROM
        UPDATERHISTORICO H
        JOIN UPDATERPRODUTOS P ON (P.ID = H.CDPRODUCTID)
        JOIN FILIAL F ON (F.CDFILIAL = H.CDFILIAL)
        LEFT JOIN OPERADOR O ON (O.CDOPERADOR = H.CDOPERADOR)
      WHERE
        H.CDPRODUCTID = :CDPRODUCTID
        AND H.CDFILIAL = :CDFILIAL
      ORDER BY
        H.DTULTATU DESC
    `;

    const params = {
      CDPRODUCTID: cdProductId,
      CDFILIAL: cdFilial,
    }
    
    return OracleService.fetchAssoc(sql, params);
  }

  getUpdaterProdutoHistoricoPorCaixa(cdProductId, cdFilial, cdCaixa) {
    const sql = `
      SELECT
        H.CDFILIAL,
        O.NMOPERADOR,
        F.NMFILIAL,
        H.CDFILIAL
        || ' - '
        || F.NMFILIAL AS FILIAL,
        C.CDCAIXA
        || ' - '
        || C.NMCAIXA AS CAIXA,
        H.CDUUID,
        H.CDPRODUCTID,
        P.NMPRODUCT,
        H.IDSTEVENTO,
        NVL(H.NRVERSAOATUAL, '-') AS NRVERSAOATUAL,
        H.NRVERSAOALVO,
        H.IDCRIARVERSAO,
        TO_CHAR(H.DTULTATU, 'DD/MM/YYYY HH24:MI:SS') AS DTULTATU
      FROM
        UPDATERHISTORICOCX H
        JOIN UPDATERPRODUTOS P ON (P.ID = H.CDPRODUCTID)
        JOIN FILIAL F ON (F.CDFILIAL = H.CDFILIAL)
        LEFT JOIN OPERADOR O ON (O.CDOPERADOR = H.CDOPERADOR)
        INNER JOIN CAIXA C ON (C.CDFILIAL = H.CDFILIAL) AND (C.CDCAIXA = H.CDCAIXA)       
      WHERE
        H.CDPRODUCTID = :CDPRODUCTID
        AND H.CDFILIAL = :CDFILIAL
        AND H.CDCAIXA = :CDCAIXA
      ORDER BY
        H.DTULTATU DESC
    `;

    const params = {
      CDPRODUCTID: cdProductId,
      CDFILIAL: cdFilial,
      CDCAIXA: cdCaixa,
    }
    
    return OracleService.fetchAssoc(sql, params);
  }
}

module.exports = new updaterHistoricoModel();
